package come.stormborntales.notevault.data.local.dao

import androidx.room.Dao
import androidx.room.Delete
import androidx.room.Insert
import androidx.room.OnConflictStrategy
import androidx.room.Query
import androidx.room.Update
import come.stormborntales.notevault.data.local.entity.NoteCollection
import kotlinx.coroutines.flow.Flow

@Dao
interface CollectionDao {

    @Query(value = "SELECT * FROM note_collections WHERE parentId IS :parentId")
    fun getCollectionsByParent(parentId: Int?): Flow<List<NoteCollection>>

    @Insert(onConflict = OnConflictStrategy.REPLACE)
    suspend fun insertCollection(collection: NoteCollection)

    @Update
    suspend fun updateCollection(collection: NoteCollection)

    @Delete
    suspend fun deleteCollection(collection: NoteCollection)

    @Query("SELECT * FROM note_collections WHERE id = :id LIMIT 1")
    suspend fun getById(id: Int): NoteCollection?

    @Query("SELECT * FROM note_collections")
    fun getAll(): Flow<List<NoteCollection>>
}