package come.stormborntales.notevault.ui.viewmodel

import androidx.lifecycle.ViewModel
import androidx.lifecycle.ViewModelProvider
import come.stormborntales.notevault.data.repository.CollectionRepository
import come.stormborntales.notevault.data.repository.NoteRepository

@Suppress("UNCHECKED_CAST")
class NoteBrowserViewModelFactory (
    private val noteRepository: NoteRepository,
    private val collectionRepository: CollectionRepository
) : ViewModelProvider.Factory {

    override fun <T : ViewModel> create(modelClass: Class<T>): T {
        if (modelClass.isAssignableFrom(NoteBrowserViewModel::class.java)) {
            return NoteBrowserViewModel(noteRepository, collectionRepository) as T
        }
        throw IllegalArgumentException("Unknown ViewModel class")
    }
}